//+------------------------------------------------------------------+
//|                                      BarClock (AAD Mods v2a).mq4 |
//|                                     Core time code by Nick Bilak |
//|                http://metatrader.50webs.com/ beluck[at]gmail.com |
//|                         Modified by adoleh2000, dwt5, and AAD... |
//+------------------------------------------------------------------+
#property copyright "Copyright 2005, Nick Bilak - 2008 Mods By AAD..."
#property link      "http://metatrader.50webs.com/"

/*
Updated: 7/11/2008 - I added customizable options (color, display text near bars on/off, 
and text size) along with a minor code fix to this indicator. It now deletes the time text 
near the bars when the indicator is removed or when the "Display Time Near Bars" option is 
set to false...

Updated: 11/17/2008 - I added the broker spread and changed the name to BarClock (AAD Mods v2)...

Updated: 11/18/2008 - I added the broker spread display around the top left hand corner of the chart and changed the name to BarClock (AAD Mods v2a)...
---

*/

#property indicator_chart_window

extern string ColorOption="---> Time Display Color Near Bars <---";
extern color  TimeDisplayColor=White;
extern string DisplayOption="---> Display Time Near Bars <---";
extern bool DisplayTimeNearBars=true;
extern string SizeOption="---> Time Display Size Near Bars (10-25) <---";
extern int DisplaySizeNearBars=10;
extern string Mods="(( Mods By AAD ))";

//---- buffers
double s1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  }
   return(0);
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
   {
   ObjectsDeleteAll(0,OBJ_TEXT);
   return(0);
   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int Spread;
   double i;
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   i=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   // Spread.
   Spread=MathRound((Ask-Bid)/Point);
   // Time functions.
   Comment( m + " Minutes and " + s + " Seconds Left to Bar End.    Spread: "+Spread+"");
   ObjectDelete("time");
   if(ObjectFind("time") !=0 && DisplayTimeNearBars==true)
   {
   ObjectCreate("time",OBJ_TEXT,0, Time[0], Close[0]+ 0.0005);
   ObjectSetText("time", "                            < "+m+":"+s+" ("+Spread+") ",DisplaySizeNearBars,"Arial",TimeDisplayColor);
   }
   else
   {
   ObjectMove("time", 0, Time[0], Close[0]+0.0005);
   }
   //---- .1 Seconds wait.
   Sleep(100);
   RefreshRates();
   return(0);
  }
//+------------------------------------------------------------------+